program surfacefft
use sep3d_struct_mod
use sep
implicit none
real :: f_min,f_max,pi,fw,dw
integer :: iw_min,iw_max,nw
integer :: nt_pad
integer :: is,ihx
integer :: blocksize_in, blocksize_out
real, allocatable :: shot(:,:)
real :: dt,ow,w_max
complex,allocatable :: shot_w(:,:),trace(:)
type(sep3d) :: data_in, data_out,din
integer,external :: sreed,srite 

call initpar()

pi=3.1415926

call init_sep3d("in",din,"INPUT")

dw=din%d(2)
nw=din%n(2)
ow=din%o(2)

w_max=ow+(nw-1)*dw

nw=w_max/dw
dt=2.0*pi/(nw*dw)


call init_sep3d(data_out,"OUTPUT","FLOAT","REGULAR",ctag="out")
call axis_allocate(data_out,3)
data_out%o(1)=din%o(1)
data_out%d(1)=din%d(1)
data_out%n(1)=din%n(1)
data_out%o(3)=din%o(3)
data_out%d(3)=din%d(3)
data_out%n(3)=din%n(3)
data_out%o(2)=0.0
data_out%d(2)=dt
data_out%n(2)=nw
call sep3d_set_sep3d(data_out)
call sep3d_write_description("out",data_out)

allocate( shot(data_out%n(1),data_out%n(2)) )
allocate( shot_w(din%n(1),din%n(2)) )
allocate(trace(nw) )

iw_min=ow/dw

blocksize_in=din%n(1)*din%n(2)*8
blocksize_out=data_out%n(1)*data_out%n(2)*4
do is=1,din%n(3)
  if ( sreed("in",shot_w,blocksize_in)/=blocksize_in) call seperr("wrong read")
  do ihx=1,din%n(1)
    trace=0.0
    trace(iw_min:nw)=shot_w(ihx,:)
    call CFFT1DE(trace,nw,-1)
    shot(ihx,:)=trace(1:nw)
  end do
  if (srite("out",shot,blocksize_out)/=blocksize_out) call seperr("wrong write")
end do

end program surfacefft
