program merge
use sep3d_struct_mod
use sep
implicit none
type(sep3d) :: cig_in,cig_out
real,allocatable :: cig_data(:,:,:)
complex,allocatable :: datazx(:,:)

logical :: vertical
integer :: ihx,ix,iz,nx,nz,nhx
real :: fkx,dkx,kx,dx,fkz,dkz,kz,dz,sinv,cosv,weight
real :: pi
integer,external :: sreed,srite

call initpar()

call from_param("vertical",vertical,.false.)
call init_sep3d("Cig_in",cig_in,"INPUT")
nz=cig_in%n(1); nx=cig_in%n(2); nhx=cig_in%n(3)
dz=cig_in%d(1); dx=cig_in%d(2)

call init_sep3d(cig_out,"OUTPUT","FLOAT","REGULAR",ctag="Cig_out")
call axis_allocate(cig_out,3)
cig_out%n=cig_in%n; cig_out%d=cig_in%d; cig_out%o=cig_in%o
call sep3d_set_sep3d(cig_out)
call sep3d_write_description("Cig_out",cig_out)

pi=3.1415926

allocate( cig_data(nz,nx,nhx),datazx(nz,nx) )
if (sreed("Cig_in",cig_data,nz*nx*nhx*4)/=nz*nx*nhx*4) call seperr("wrong read")

fkx=-pi/dx; fkz=-pi/dz
dkx=2.0*pi/(nx*dx); dkz=2.0*pi/(nz*dz)
write(*,*) "max",maxval(abs(cig_data))
do ihx=1,nhx
   write(*,*) "ihx=",ihx,"nhx",nhx
   datazx=cmplx(cig_data(:,:,ihx),0.0)
   write(*,*) "max",maxval(abs(real(datazx)))
   write(*,*) "before +1 fft"
   do ix=1,nx
     call segFFT1D( datazx(:,ix),nz,+1 )
   end do
   do iz=1,nz
     call segFFT1D( datazx(iz,:),nx,+1 )
   end do

   write(*,*) "end +1 fft"
   write(*,*) "max",maxval(abs(real(datazx)))

   do ix=1,nx
     kx=(ix-1)*dkx+fkx
     do iz=1,nz
       kz=(iz-1)*dkz+fkz
       if (kz==0.0 .and. kx==0.0) then
       else
         sinv=sqrt(kx*kx/(kx*kx+kz*kz))
         cosv=sqrt(kz*kz/(kx*kx+kz*kz))
       end if
       if (vertical ) then
         weight=sinv*sinv
       else
         weight=cosv*cosv
       end if
       if (ihx==1) write(*,*) weight
       datazx(iz,ix)=datazx(iz,ix)*weight
     end do
   end do
   write(*,*) "max",maxval(abs(real(datazx)))
   
   write(*,*) "before -1 fft"
   do ix=1,nx
     call segFFT1D( datazx(:,ix),nz,-1 )
   end do
   do iz=1,nz
     call segFFT1D( datazx(iz,:),nx,-1 )
   end do
   write(*,*) "end -1 fft"
    write(*,*) "max",maxval(abs(real(datazx)))
   cig_data(:,:,ihx)=real (datazx)
end do
if (srite("Cig_out",cig_data,nz*nx*nhx*4)/=nz*nx*nhx*4) call seperr("rite err")

deallocate(cig_data,datazx)
end program merge
