program rr
use sep3d_struct_mod
use sinc_f90_mod

implicit none
type(sep3d)::s2d,s3d
integer :: ix,iy,ir,i_ir
real :: x,y,r,wr
real,allocatable :: shot2d(:,:),shot3d(:,:,:)
real :: sincx(8)

integer,external:: sreed,srite

call initpar()

call init_sep3d("2Dshot",s2d,"INPUT")
call init_sep3d(s3d,"OUTPUT","FLOAT","REGULAR",ctag="3Dshot")
call axis_allocate(s3d,3)
s3d%o(1)=s2d%o(1); s3d%d(1)=s2d%d(1); s3d%n(1)=s2d%n(1)
s3d%o(2)=s2d%o(2); s3d%d(2)=s2d%d(2); s3d%n(2)=s2d%n(2)
s3d%o(3)=s2d%o(2); s3d%d(3)=s2d%d(2); s3d%n(3)=s2d%n(2)
call sep3d_set_sep3d(s3d)
call sep3d_write_description("3Dshot",s3d)

allocate( shot2d(s2d%n(1),s2d%n(2)), shot3d(s3d%n(1),s3d%n(2),s3d%n(3)) )

if (sreed("2Dshot",shot2d,s2d%n(1)*s2d%n(2)*4)/=s2d%n(1)*s2d%n(2)*4) call seperr("err read")

shot3d=0.0
do iy=1,s3d%n(3)
  y=s3d%o(3)+(iy-1)*s3d%d(3)
  do ix=1,s3d%n(2)
    x=s3d%o(2)+(ix-1)*s3d%d(2)
    r=sqrt(y*y+x*x)
    ir=(r-s2d%o(2))/s2d%d(2)+1
    wr=(r-(s2d%o(2)+(ir-1)*s2d%d(2)) )/s2d%d(2)
    call sinc_f90_mksinc(wr,8,sincx)
    do i_ir=1,8
      if (i_ir-4+ir >0 .and. i_ir-4+ir <= s2d%n(2) )then
        shot3d(:,ix,iy)=shot3d(:,ix,iy)+shot2d(:,i_ir-4+ir)*sincx(i_ir)
      end if
    end do
  end do
end do

if (srite("3Dshot",shot3d,s3d%n(1)*s3d%n(2)*s3d%n(3)*4)/=s3d%n(1)*s3d%n(2)*s3d%n(3)*4) call seperr("er rite")

deallocate(shot2d,shot3d)

end program rr
