program sin_interp
use sep3d_struct_mod
use sinc_f90_mod

implicit none
real :: dxin,dxout
type(sep3d):: datain,dataout
integer :: blocksize_read,blocksize_rite
integer :: ix,iw,ihy,ihx
integer :: ix_interp,i_ix_interp
real    :: wx_interp,hx
real    :: sincx(16)
complex,allocatable :: data_in(:),data_out(:)

integer,external :: sreed,srite

call initpar()

dxout=5.0
call init_sep3d("Datain",datain,"INPUT")
dxin= datain%d(1)
call init_sep3d(dataout, "OUTPUT","COMPLEX", "REGULAR", ctag="Dataout")
call axis_allocate(dataout,4)
dataout%d(1:4)=datain%d; dataout%o(1:4)=datain%o; dataout%n=datain%n
dataout%d(1)=dxout; dataout%o(1)=datain%o(1); dataout%n(1)= datain%d(1)* datain%n(1)/dxout
call sep3d_set_sep3d(dataout)
call sep3d_write_description("Dataout",dataout)

allocate( data_in(datain%n(1)),data_out(dataout%n(1)) )

blocksize_read=8*datain%n(1)
blocksize_rite=8*dataout%n(1)

do ix=1,datain%n(4)
  do iw=1,datain%n(3)
    do ihy=1,datain%n(2)
       if (sreed("Datain",data_in,blocksize_read)/=blocksize_read) call seperr("err reed")
       do ihx=1,dataout%n(1)
         hx=dataout%o(1)+(ihx-1)*dataout%d(1)
         ix_interp=(hx-datain%o(1))/datain%d(1)+1
         wx_interp=(hx-((ix_interp-1)*datain%d(1)+datain%o(1)))/datain%d(1)
         call sinc_f90_mksinc(wx_interp,16,sincx)
         do i_ix_interp=1,16
           if (ix_interp-8+i_ix_interp >0 .and. ix_interp-8+i_ix_interp <= datain%n(1) ) then
             data_out(ihx)=data_out(ihx)+data_in(ix_interp-8+i_ix_interp)*sincx(i_ix_interp)
           end if
         end do
       end do
       if (srite("Dataout",data_out,blocksize_rite)/=blocksize_rite) call seperr("err rite")
    end do
  end do
end do
deallocate( data_in, data_out)
end program sin_interp
