program wavefield
use shot_kernal_mod
use rot_pw
use data_mod
use sep3d_struct_mod
use sep
use sinc_f90_mod

implicit none
type(sep3d):: wavfld
complex,allocatable:: source(:,:),src(:,:)
complex,allocatable:: wld(:,:),wavefld(:,:,:,:)
integer :: nz,nx,ny,ns,i_w,i_z,i_x,nw,i_p
real,allocatable :: vel(:,:)
integer,allocatable ::s_ix(:),s_iz(:),six,siz
complex,allocatable ::s_wld(:) 
real,allocatable :: s_wx(:),s_wz(:),swx,swz
real :: vz,dx,dy,dz,fd_a,fd_b,fd_trick,w,ang_rotate,pi,s_dx,dw,w0
real :: mig_x_min,mig_y_min
integer :: i_s_ix,s_nx
real :: x_rotate,z_rotate,s_x
real :: sincx(8),sincz(8)
integer ::i_itx,i_itz
logical :: is2d
integer,external :: auxin,sreed,srite


call initpar()
nx=128; nz=300; ny=1
s_nx=400
is2d=.true.
dx=25.0; dy=25.0; dz=3.0
s_dx=5.0
fd_a=0.5; fd_b=0.25; fd_trick=1.0/6.0

pi=3.1415926
ang_rotate=pi/6.0
!ang_rotate=0.0

call data_mod_init(ns,nw,dx,dy,dw,w0,0)

call plane_1shot_init(1,mig_x_min,mig_y_min,nx,ny,0)

call init_sep3d(wavfld, "OUTPUT","COMPLEX", "REGULAR", ctag="Wavefield")
call axis_allocate(wavfld,3)
wavfld%n(1)=nz; wavfld%d(1)=dz; wavfld%o(1)=0.0
wavfld%n(2)=nx; wavfld%d(2)=dx; wavfld%o(2)=mig_x_min
wavfld%n(3)=nw;wavfld%d(3)= dw; wavfld%o(3)=w0
call sep3d_set_sep3d(wavfld)
call sep3d_write_description("Wavefield",wavfld)

allocate(wld(nx,ny),vel(nx,ny),wavefld(nz,nx,ny,nw) )
allocate( source(nz,nx),src(nx,1) )
vel=2000.0
vz=2000.0


call shot_ker_init(nx,ny)
call ker_p_init(1,nx,ny,dx,dy,dz,fd_a,fd_b,fd_trick,is2d)
call rot_init(nz,nx,dz,dx,nz,nx)
i_p=1
do i_w=1,nw
  call plane_source(mig_x_min,mig_y_min,nx,ny,i_w,i_p,src) 
  wld=0.0
  w=(i_w-1)*dw+w0
  write(*,*) w, "max",maxval(real(src))
  source=0.0
  !do i_s_ix=1,s_nx
  !  s_x=(i_s_ix-1)*s_dx
  !  x_rotate=s_x*cos(ang_rotate)
  !  z_rotate=s_x*sin(ang_rotate)
  !  six=(x_rotate-0.0)/dx+1
  !  siz=(z_rotate-0.0)/dz+1
  !  swx=(x_rotate-(six-1)*dx)/dx
  !  swz=(z_rotate-(siz-1)*dz)/dz
  !  call sinc_f90_mksinc(swx,8,sincx) 
  !  call sinc_f90_mksinc(swz,8,sincz)
  !  if (six > 3 .and. six < nx-3) then
  !    if (siz > 3 .and. siz < nz-3 ) then
  !      do i_itx=1,8
  !        do i_itz=1,8
  !          !source(siz-4+i_itz,six-4+i_itx)=source(siz-4+i_itz,six-4+i_itx)+wavelet(i_w)*sincx(i_itx)*sincz(i_itz)
  !        end do
  !      end do
  !    end if
  !  end if
  !end do
  write(*,*) "max",maxval(real(src))
  do i_s_ix=1,nx
    s_x=(i_s_ix-1)*dx
    x_rotate=s_x*cos(ang_rotate);     z_rotate=s_x*sin(ang_rotate)
    six=(x_rotate-0.0)/dx+1;          siz=(z_rotate-0.0)/dz+1
    swx=(x_rotate-(six-1)*dx)/dx;     swz=(z_rotate-(siz-1)*dz)/dz
    call sinc_f90_mksinc(swx,8,sincx); call sinc_f90_mksinc(swz,8,sincz)
    !write(*,*) "n test",six,"z",siz
    !if (six > 3 .and. six < nx-3) then
    !  if (siz > 3 .and. siz < nz-3 ) then
    !    do i_itx=1,8
    !      do i_itz=1,8
    !        source(siz-4+i_itz,six-4+i_itx)=source(siz-4+i_itz,six-4+i_itx)+src(i_s_ix,1)*sincx(i_itx)*sincz(i_itz)
    !      end do
    !    end do
    !  end if
    !end if
    source(1,i_s_ix)=source(1,i_s_ix)+src(i_s_ix,1)
  end do
  write(*,*) "max1",maxval(real(source))
  do i_z=1,nz
    call shot_ker_depth_onestep(wld,vel,vz,w,-1)
    do i_x=1,nx
      wld(i_x)=wld(i_x)+source(i_z,i_x)
    end do
    wavefld(i_z,:,:,i_w)=wld
  end do
end do

if (srite("Wavefield",wavefld,nx*nz*nw*8)/=nx*nz*nw*8) call seperr("Image write wrong")

call shot_ker_release
deallocate(wld,vel,wavefld,source)
end program wavefield
